from socket import socket, AF_INET, SOCK_STREAM, error
from struct import pack
from contextlib import closing
import sys

nickname = sys.argv[1]
hostname, port = sys.argv[2], int(sys.argv[3])

s = socket(AF_INET, SOCK_STREAM)
s.connect((hostname, port))

with closing(s):
    while True:
        msg = input('[{0}] '.format(nickname))
        if msg == ':q':
            try:
                s.sendall(pack('!l', -1)) # ! - network byte order; l - long
            except error:
                print('unable to send closing message')
            finally:
                break
        else:
            msg = '[{0}] {1}'.format(nickname, msg)
            msg = msg.encode('utf8')

        msg_header = pack('!l', len(msg))
        try:
            s.sendall(msg_header)
            s.sendall(msg)
        except error:
            print('unable to send message')
            break

        print('ok')
