from socket import socket, AF_INET, SOCK_STREAM
from contextlib import closing, nested
from functools import partial
import sys

log = partial(print, file=sys.stderr)

hostname, port = sys.argv[1], int(sys.argv[2])

s = socket(AF_INET, SOCK_STREAM)
s.bind((hostname, port))

s.listen(1)
log('listening on port', port)

(conn, addr) = s.accept()
log('accepted client from', addr)

with nested(closing(s), closing(conn)):
    while True:
        chunk = conn.recv(4096)
        if len(chunk) == 0:
            log('message recieved')
            break
        else:
            log('recieved', len(chunk), 'bytes')
            sys.stdout.buffer.write(chunk)
